package com.shxy.i2.bean;

import lombok.Data;

import java.io.Serializable;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

/**
 * 线路树状图列表
 */
@Data
public class ListModel implements Serializable {

    private List<Beans> list = new ArrayList<>();

    @Data
    public static class Beans {

        private String name;

        private BigInteger history;//历史数据量

        private BigInteger uploadnum;//已上传数据量

        private BigInteger nownum;//今日数据量

        private BigInteger nowuploadnum;//今日上传数据量
    }



}
